/*
 * exemplo : Expresses Aritmticas de inteiros.
 */ 

/*
 Expr : expr_Leaf (INT)
      | expr_Node ({op    :: (INT INT)->INT}
                   {left  :: Expr}
                   {right :: Expr})
      ;
*/

# include <stdio.h>
# include <stdlib.h>
# include "Prelude.h"
# include "expr.h"
# include "expr_cata.h"
# include "expr.c"
# include "expr_cata.c"

int fadd (int i, int a)
{ return (i+a) ; };
int fsub (int i, int a)
{ return (i - a); };
int fmul (int i, int a)
{ return (i * a); };

int eval_expr(Expr a)
{ extern void * eval_leaf(int);
  extern void * eval_node(int (*) (int,int), void *,void *);
  return ((int) cata_Expr(a,either_Expr(eval_leaf,eval_node)));
}

void * eval_leaf (int i)
{ return (void *) i; };
void * eval_node (int (*f) (int,int),void *l,void *r)
{ return (void *) f((int)l,(int)r); }


int main(void)
{
 /* (3 * 10) + (5 - 2) */
 Expr exemplo =
               expr_Node(fadd,
                         expr_Node(fmul,
                                   expr_Leaf(3),
                                   expr_Leaf(10)
                                  ),
                         expr_Node(fsub,
                                   expr_Leaf(5),
                                   expr_Leaf(2)
                                  )
                        ); 
  printf("exemplo        = (3 * 10) + (5 - 2)\n");
  printf("exemplo (show) = %s\n",string_toCStr(show_Expr(exemplo)));
  printf("exemplo (eval) = %i\n",eval_expr(exemplo));


  free(exemplo);
  
  return 0;
};

