%{
#include <string.h>
#include "lrclib.h"
#include <EVALUATOR/evaluator.h>
#include "bcode.tab.h"
#ifdef PROCESS_WHITESPACE
extern void process_whitespace(char *);
#define LRC_PROCESS_WHITESPACE(s) process_whitespace(s); lrc_process_whitespace(s)
#else
#define LRC_PROCESS_WHITESPACE(s) lrc_process_whitespace(s)
#endif
%}

%option stack
%s COMMENT
%%
\/\* { BEGIN COMMENT; LRC_PROCESS_WHITESPACE(yytext); }
<COMMENT>\*\/ { BEGIN INITIAL; LRC_PROCESS_WHITESPACE(yytext); }
<COMMENT>(.|[\n])* { LRC_PROCESS_WHITESPACE(yytext); }
[\ \t\n]+|"--".*[\n]|"//".*[\n] { LRC_PROCESS_WHITESPACE(yytext); }
"STR" { yylval.str_val=lrc_extract_token(yytext); return gen_id_4; }
"BOOL" { yylval.str_val=lrc_extract_token(yytext); return gen_id_5; }
"REAL" { yylval.str_val=lrc_extract_token(yytext); return gen_id_6; }
"INT" { yylval.str_val=lrc_extract_token(yytext); return gen_id_7; }
"PTR" { yylval.str_val=lrc_extract_token(yytext); return gen_id_8; }
"CHAR" { yylval.str_val=lrc_extract_token(yytext); return gen_id_9; }
"ANYTYPE" { yylval.str_val=lrc_extract_token(yytext); return gen_id_10; }
# { yylval.str_val=lrc_extract_token(yytext); return gen_id_11; }
[cC][oO][dD][eE] { yylval.str_val=lrc_extract_token(yytext); return gen_id_12; }
[oO][pP][tT][iI][mM][iI][zZ][eE] { yylval.str_val=lrc_extract_token(yytext); return gen_id_13; }
[cC][oO][mM][mM][eE][nN][tT][sS] { yylval.str_val=lrc_extract_token(yytext); return gen_id_14; }
[cC][oO][dD][eE]_[wW][iI][dD][tT][hH] { yylval.str_val=lrc_extract_token(yytext); return gen_id_15; }
[yY][eE][sS] { yylval.str_val=lrc_extract_token(yytext); return gen_id_16; }
[nN][oO] { yylval.str_val=lrc_extract_token(yytext); return gen_id_17; }
[0-9]+ { yylval.str_val=lrc_extract_token(yytext); return gen_id_18; }
[a-zA-Z][a-zA-Z_0-9]* { yylval.str_val=lrc_extract_token(yytext); return gen_id_19; }
. { return yytext[0]; }
%%
void lrc_set_scanner_start_state(char * ss) {
if (lrc_string_equal(ss,"COMMENT")) { yy_push_state(COMMENT); return; }
if (lrc_string_equal(ss,"INITIAL")) { yy_push_state(INITIAL); return; }}
void lrc_pop_scanner_start_state() {
  yy_pop_state();
}
