#ifndef _LRCLIB_INCLUDED
#define _LRCLIB_INCLUDED
/*
** lrclib.h
** 
** DO NOT CHANGE THIS FILE.
** THIS FILE IS GENERATED FROM headers.noweb
**
*/

#define LRC_LIB_VERSION "BASE;INITIAL TERMS"

#include <stdio.h>
#define FAT


#include <stddef.h>


/* memory management */
void * lrc_malloc(size_t s);
void * lrc_calloc(size_t n, size_t m);
void lrc_free(void * p);
void * lrc_realloc(void * p, size_t s);
void * ALLOC_STR(size_t n);




/* basics */
typedef int   lrc_bool;
typedef void *lrc_ptr;

extern const lrc_bool lrc_true;
extern const lrc_bool lrc_false;

extern const int lrc_less;
extern const int lrc_equal;
extern const int lrc_greater;



/* shalloc */
/* A prime p that can not be written as (2^k)-1 
** some primes 11,101,1009,10007,100003 */
#define lrc_term_tabelsize 100003

typedef unsigned int lrc_term_ix;

#define FIELD(buf,offset,type)   (*(type*)((int)(buf)+offset))

typedef lrc_ptr *lrc_term;
#ifdef FAT
#define LRC_USER_FIELDS_OFFSET 6
#else
#define LRC_USER_FIELDS_OFFSET 3
#endif
#define LRC_USER_DATA(term) ((term)+LRC_USER_FIELDS_OFFSET)
#define LRC_USER_FIELD(typ,term,fnum) ((typ)((term)[LRC_USER_FIELDS_OFFSET+fnum]))
#define LRC_TAG(t)            LRC_USER_FIELD(int,t,0)
#define LRC_CHILD(t,i)        LRC_USER_FIELD(lrc_term,t,i)

#define LRC_ADDRESS_PRIMITIVE(term) ((lrc_term)(term)+1+LRC_USER_FIELDS_OFFSET)
#define LRC_VALUE_GENERAL(term,type)  (*(type*)(LRC_ADDRESS_PRIMITIVE(term)))

#define LRC_VALUE_int(t) LRC_VALUE_GENERAL(t,int)
#define LRC_VALUE_char(t) LRC_VALUE_GENERAL(t,char)
#define LRC_VALUE_lrc_bool(t) LRC_VALUE_GENERAL(t,lrc_bool)
#define LRC_VALUE_lrc_string(t) LRC_VALUE_GENERAL(t,lrc_string)
#define LRC_VALUE_lrc_map(t) LRC_VALUE_GENERAL(t,lrc_map)
#define LRC_VALUE_lrc_attr(t) LRC_VALUE_GENERAL(t,lrc_attr)
/* #define LRC_VALUE_lrc_ptr(t) LRC_VALUE_GENERAL(t,lrc_ptr) */
#define LRC_VALUE_lrc_ptr(t) t

#define LRC_VALUE_lrc_real(t) lrc_value_real(t)

#define LRC_VALUE(t,type)     LRC_VALUE_ ## type(t)

void lrc_all_terms_in_cache(void action(lrc_term));

void remove_unmarked_terms(void);

#ifdef TRACE
void define_term_tracer(void tracer());
#endif
 
void lrc_term_register_hit(lrc_ptr); 
typedef lrc_bool lrc_comparer(lrc_term,lrc_ptr);
lrc_term lrc_shared_prim(lrc_term_ix i,lrc_comparer eq,int size,lrc_ptr buf);

lrc_term lrc_shared_cons(int size,lrc_term buf);


lrc_term lrc_term0(int);
lrc_term lrc_term1(int,lrc_term);
lrc_term lrc_term2(int,lrc_term,lrc_term);
lrc_term lrc_term3(int,lrc_term,lrc_term,lrc_term);
lrc_term lrc_term4(int,lrc_term,lrc_term,lrc_term,lrc_term);
lrc_term lrc_term5(int,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term);
lrc_term lrc_term6(int,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term);
lrc_term lrc_term7(int,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term);
lrc_term lrc_term8(int,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term);
lrc_term lrc_term9(
   int,
   lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term);
lrc_term lrc_term10(
   int,
   lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term);
lrc_term lrc_termhuge(int,...);

lrc_term lrc_build_term(char *,...);

void mark_term(lrc_term t);


/* ints 0 */
#define T__Int 0

  lrc_term C_Int(int);
       int lrc_int_compare(int,int);
       int lrc_int_compare_term(lrc_term, lrc_term);
  lrc_bool lrc_int_equal(int,int);
  lrc_bool lrc_int_equal_term(lrc_term, lrc_term);
       int lrc_int_default(void);


/* bools 1 */
#define T__Bool 1

lrc_term C_Bool(lrc_bool);
     int lrc_bool_compare(lrc_bool,lrc_bool);
     int lrc_bool_compare_term(lrc_term, lrc_term);
lrc_bool lrc_bool_equal(lrc_bool,lrc_bool);
lrc_bool lrc_bool_equal_term(lrc_term, lrc_term);
lrc_bool lrc_bool_default(void);

/* chars 2 */
#define T__Char 2

lrc_term C_Char(char);
     int lrc_char_compare(char,char);
     int lrc_char_compare_term(lrc_term, lrc_term);
lrc_bool lrc_char_equal(char,char);
lrc_bool lrc_char_equal_term(lrc_term, lrc_term);
    void lrc_char_fprint(FILE * f, char c);
    void lrc_char_print(char);
    char lrc_char_default(void);

/* reals 3 */
typedef double lrc_real; 

#define T__Real 3

  lrc_term C_Real(lrc_real);
       int lrc_real_compare(lrc_real,lrc_real);
       int lrc_real_compare_term(lrc_term, lrc_term);
  lrc_real lrc_value_real(lrc_term);
  lrc_bool lrc_real_equal(lrc_real,lrc_real);
  lrc_bool lrc_real_equal_term(lrc_term, lrc_term);
  lrc_real lrc_real_default(void);

/* strs 4 */
typedef char * lrc_string; 

#define T__Str 4

  lrc_term C_Str(lrc_string);
       int lrc_string_compare(lrc_string,lrc_string);
       int lrc_string_compare_term(lrc_term, lrc_term);
  lrc_bool lrc_string_equal(lrc_string,lrc_string);
  lrc_bool lrc_string_equal_term(lrc_term, lrc_term);
      void lrc_string_print(lrc_string);

lrc_string lrc_string_const(lrc_string);
lrc_string lrc_string_concat(lrc_string,lrc_string);
lrc_string lrc_vstring_concat(lrc_string,...);
lrc_string lrc_string_sub(lrc_string,int,int);
lrc_string lrc_string_opensub(lrc_string,int);
      char lrc_string_index(lrc_string,int);

lrc_string lrc_string_default(void);

lrc_string lrc_string_copy(lrc_string);


/* toks 5 */
#define T__Tok 5
#define C_Tok(t) C_Str(t)


/* ptrs 6 */
#define T__Ptr 6

  lrc_term C_Ptr(lrc_ptr);
       int lrc_ptr_compare(lrc_ptr, lrc_ptr);
       int lrc_ptr_compare_term(lrc_term, lrc_term);
  lrc_bool lrc_ptr_equal(lrc_ptr, lrc_ptr);
  lrc_bool lrc_ptr_equal_term(lrc_term, lrc_term);

    extern const lrc_ptr lrc_nil;
   lrc_ptr lrc_ptr_default(void);

/* maps 7 */
typedef struct rec_AVL *AVL_tp;

typedef struct rec_AVL {
  int height;
  int hash;
  AVL_tp left;
  lrc_term key;
  lrc_term value;
  AVL_tp right;
} rec_AVL;

typedef int compare_function_tp();
typedef lrc_bool equal_function_tp();

typedef struct lrc_map {
  lrc_term              default_value;
  AVL_tp                avl;
  equal_function_tp   * equal_key;
  compare_function_tp * compare_key;
  equal_function_tp   * equal_value;
  compare_function_tp * compare_value;
} lrc_map;

#define T__Map 7

  lrc_term C_Map(lrc_map);
       int lrc_map_compare(lrc_map, lrc_map); 
       int lrc_map_compare_term(lrc_term, lrc_term); 
  lrc_bool lrc_map_equal(lrc_map, lrc_map);
  lrc_bool lrc_map_equal_term(lrc_term, lrc_term);
      void lrc_map_print(lrc_map, void print_key(), void print_value());
      void mark_map(lrc_term);

extern lrc_map lrc_empty_map(
      equal_function_tp *,
      compare_function_tp *,
      equal_function_tp *,
      compare_function_tp *,
      lrc_term
   );

  lrc_term lrc_map_application  (lrc_term, lrc_map);
  lrc_bool lrc_map_in           (lrc_term, lrc_map);
   lrc_map lrc_map_single_update(lrc_term, lrc_term, lrc_map);
   lrc_map lrc_map_update       (lrc_map,  lrc_map);
   lrc_map lrc_map_init         (lrc_map,  lrc_term, int);

      void map_forall(lrc_map m, void action());
      void map_forall_keys(lrc_map m, void action());
       int map_num_keys(lrc_map m);


/* attrs 8 */
typedef lrc_ptr lrc_attr; 

#define T__Attr 8

  lrc_term C_Attr(lrc_attr);
       int lrc_attr_compare(lrc_attr, lrc_attr);
       int lrc_attr_compare_term(lrc_term, lrc_term);
  lrc_bool lrc_attr_equal(lrc_attr, lrc_attr);
  lrc_bool lrc_attr_equal_term(lrc_term, lrc_term);

    extern const lrc_attr lrc_nil_attr;


/* memo */
typedef lrc_term lrc_packet;
typedef void (*lrc_visfun)(lrc_packet,lrc_packet);

extern int lrc_memo(lrc_visfun f,int ipsize,lrc_packet ip,int opsize,lrc_packet op);

#define LRC_MEMOS(f,ip,op) lrc_memo(f,sizeof(ip),(lrc_packet)(&ip),\
                                      sizeof(op),(lrc_packet)(&op))
#define LRC_MEMOP(f,ip,op) lrc_memo(f,sizeof(*ip),(lrc_packet)(ip),\
                                      sizeof(*op),(lrc_packet)(op))

extern void lrc_memo_strategy_config (int,int,int);
extern void lrc_memo_tree_size_config (int,int);
extern void lrc_memo_init(void);
extern void lrc_memo_start_AE(void);
extern void lrc_memo_end_AE(void);


extern void lrc_memo_statistics(int * num_allocs, int * num_hits);





/* prims */
#define lrc_first_free_tag 9

void lrc_lib_init(void);
void lrc_lib_mark(void);
lrc_term lrc_list_append(int empty_tag, lrc_term l1, lrc_term l2);
#define lrc_ident(x) (x)

int LrcCompareTrees(lrc_term,lrc_term);
int lrc_primitive_compare(lrc_term, lrc_term);

int lrc_term_equal(lrc_term, lrc_term);

/* foreign */
       int CHARtoINT(char);

       int Min(const int,const int);
       int Max(const int,const int);
  lrc_real INTtoREAL(int);
      char INTtoCHAR(int);
lrc_string INTtoSTR(int);

       int REALtoINT(lrc_real);
lrc_string REALtoSTR(lrc_real);

lrc_string STRtolower(lrc_string);
lrc_string STRtoupper(lrc_string);
       int STRlen(lrc_string);
       int STRtoINT(lrc_string);
  lrc_real STRtoREAL(lrc_string);
       int STRindex(lrc_string,char);
lrc_string repeatCHAR(char,int);

lrc_string PTRtoSTR(lrc_ptr);

/*
** Diagnostics
** from shalloc/memo/prims
*/
int  lrc_term_time(void);

int lrc_term_hashix(lrc_term);
int lrc_term_hits(lrc_term);
int lrc_term_birth(lrc_term);
int lrc_term_nnodes(lrc_term t);
int lrc_term_size(lrc_term t);
int lrc_term_occupied_size(lrc_term t);
int lrc_term_mark(lrc_term t);

typedef void lrc_term_printer(lrc_term);
typedef lrc_bool lrc_term_filter(lrc_term);

void lrc_term_dump_set_birth_time(int);
void lrc_term_dump(lrc_term_filter,lrc_term_printer);
void lrc_term_stats(int level);



void lrc_dump_reset(void);

lrc_bool lrc_filter_true(lrc_term);

typedef void (*lrc_prim_print_function)(lrc_term);
void lrc_prim_print_address(lrc_term);
void lrc_prim_print_short(lrc_term);
void lrc_prim_print_untagged(lrc_term);
void lrc_prim_print_tagged(lrc_term);
void lrc_prim_print_install(lrc_prim_print_function);

typedef void (*lrc_term_print_function)(lrc_term);
void lrc_term_print_address(lrc_term);
void lrc_term_print_short(lrc_term);
void lrc_term_print_long(lrc_term);
void lrc_term_print_install(lrc_term_print_function);

void lrc_term_print_indent(lrc_term, int);
void lrc_term_fprint_indent(FILE * f, lrc_term t, int usr_indent_delta);

typedef lrc_term lrc_cell;
typedef void (*lrc_cell_print_function)(lrc_cell);
void lrc_cell_print_fipop(lrc_cell);
void lrc_cell_print_install(lrc_cell_print_function);

int  lrc_memo_time(void);


       int lrc_memo_hits(lrc_cell);
       int lrc_memo_birth(lrc_cell);
lrc_visfun lrc_memo_visfun(lrc_cell);

typedef void lrc_memo_printer(lrc_cell);
typedef lrc_bool lrc_memo_filter(lrc_cell);

void lrc_memo_dump_set_birth_time(int);
void lrc_memo_dump(lrc_memo_filter,lrc_memo_printer);
void lrc_memo_stats(int level);







#ifdef DEBUG
#  define Assert(c,s) if(!(c)) { printf("Assertion error %s\n",s); exit(1); }
#  define AssertI(c,s,i) if(!(c)) { printf("Assertion error %s %d\n",s,i); exit(1); }
#  define DebugStatement(s) s;
#  define DebugDeclaration(d) d;
#else
#  define Assert(c,s) 
#  define AssertI(c,s,i)
#  define DebugStatement(s)
#  define DebugDeclaration(d)
#endif
typedef enum
  { PS_OK, PS_FILE_NOT_READABLE, PS_NO_ENTRY, PS_SYNTAX_ERROR } lrc_parse_state_tp;
void               lrc_set_parse_state(lrc_parse_state_tp);
lrc_parse_state_tp lrc_parse_state(void);
void               lrc_process_whitespace(char * yytext);
lrc_string         lrc_extract_token(char * yytext);
void               lrc_clear_parse_position(void);
void               lrc_get_parse_position(int *line, int *col);

lrc_term lrc_parse_string(lrc_string,int);







#ifndef POSITION_H
#define POSITION_H

typedef struct position {
  int row,col;
} Position;

typedef struct range {
  Position start,end;
} Range;

int p_smaller(Position,Position);
#define p_equal(p1,p2) ((p1.row==p2.row)&&(p1.col==p2.col))
#define p_is_legal(p) (p.row>=1 && p.col>=0)

#define pos_eq(p1,p2)   p_equal(p1,p2)
#define pos_less(p1,p2) ((p1.row < p2.row) || (p1.row==p2.row && p1.col < p2.col))
#define pos_leq(p1,p2)  (pos_less(p1,p2) || pos_eq(p1,p2))
#define pos_gt(p1,p2)   ((p1.row > p2.row) || (p1.row==p2.row && p1.col > p2.col))
#define pos_geq(p1,p2)  (pos_gt(p1,p2) || pos_eq(p1,p2))


#define END 999999

#endif
#ifndef TEXTBUFFER_H
#define TEXTBUFFER_H
/* TEXTBUFFER */
typedef struct textbuffer {
  char *content;
  int size;  /* number of bytes in content */
  int free;  /* number of unused bytes in content */
} *Textbuffer;

Textbuffer textbuffer_init(void);
void       textbuffer_clear_content(Textbuffer tb);
void       textbuffer_store(Textbuffer,char *);
void       textbuffer_append(Textbuffer,char *);
void       textbuffer_append_char(Textbuffer tb, char c);
void       textbuffer_append_n_chars(Textbuffer tb, int n, char c);
int        textbuffer_used_size(Textbuffer tb);
#define    textbuffer_retrieve(tb) tb->content
#define    textbuffer_size(tb) tb->size

#endif
#define ADMIN_SIZE      6
#define CELL_SIZE(s)    (ADMIN_SIZE*sizeof(lrc_ptr)+(s))
#define ADMIN(t,n,tp)   (*(((tp*)(t))+(n)))
#define SIZE(t)         ADMIN(t,ADMIN_SIZE-1,int)

#define SHADOW(t)       ADMIN(t,ADMIN_SIZE-4,lrc_ptr)
#define BITS(t)         ADMIN(t,ADMIN_SIZE-5,int)
#define PARENT(t)       ADMIN(t,ADMIN_SIZE-6,lrc_ptr)

#define TERM_NULL       ((lrc_term)0)

lrc_term  lrc_create_initial(lrc_term term);
lrc_term  lrc_initial_parent(lrc_term term);
lrc_term  lrc_initial_root(lrc_term term);
lrc_term  lrc_initial_shadow(lrc_term term);
lrc_bool  lrc_is_initial(lrc_term term);
lrc_term  lrc_replace_initial(lrc_term operand,lrc_term replacement);
int       lrc_is_primitive(lrc_term);

lrc_term_ix  lrc_initial_index_parent(lrc_term term);
lrc_term     lrc_shadow(lrc_term term);

lrc_term initial_replace_child(lrc_term tree, int child_num, lrc_term replacement);
lrc_term shadow_replace_child(lrc_term tree, int child_num, lrc_term replacement);


#ifndef H_MAP_OPERATIONS
#define H_MAP_OPERATIONS
#define map_ib_new(def) lrc_empty_map(lrc_int_equal_term,lrc_int_compare_term,lrc_bool_equal_term,lrc_bool_compare_term,C_Bool(def))
#define map_ii_new(def) lrc_empty_map(lrc_int_equal_term,lrc_int_compare_term,lrc_int_equal_term,lrc_int_compare_term,C_Int(def))
#define map_is_new(def) lrc_empty_map(lrc_int_equal_term,lrc_int_compare_term,lrc_string_equal_term,lrc_string_compare_term,C_Str(def))
#define map_si_new(def) lrc_empty_map(lrc_string_equal_term,lrc_string_compare_term,lrc_int_equal_term,lrc_int_compare_term,C_Int(def))
#define map_tb_new(def) lrc_empty_map(lrc_term_equal,LrcCompareTrees,lrc_bool_equal_term,lrc_bool_compare_term,C_Bool(def))
#define map_ti_new(def) lrc_empty_map(lrc_term_equal,LrcCompareTrees,lrc_int_equal_term,lrc_int_compare_term,C_Int(def))

lrc_bool   map_ib_apply(lrc_map map, int int_key);
int        map_ii_apply(lrc_map map, int int_key);
lrc_string map_is_apply(lrc_map map, int int_key);
int        map_si_apply(lrc_map map, lrc_string str_key);
lrc_bool   map_tb_apply(lrc_map map, lrc_term trm_key);
int        map_ti_apply(lrc_map map, lrc_term trm_key);
lrc_term   map_keys(lrc_map map, int bin_prod, int null_prod);
lrc_term   map_values(lrc_map map, int bin_prod, int null_prod);
lrc_term   map_map_values(lrc_map map, lrc_term f(), int bin_prod, int null_prod);

lrc_map map_ib_set(lrc_map map, int int_key, lrc_bool bool_val);
lrc_map map_ii_set(lrc_map map, int int_key, int int_val);
lrc_map map_is_set(lrc_map map, int int_key, lrc_string string_val);
lrc_map map_si_set(lrc_map map, lrc_string string_key, int int_val);
lrc_map map_ti_set(lrc_map map, lrc_term term_key, int int_val);
lrc_map map_tb_set(lrc_map map, lrc_term term_key, lrc_bool bool_val);

lrc_map lrc_map_default(void);
#endif

#ifndef H_TERM_IO
#define H_TERM_IO
typedef struct {
 int status;
 char * message;
 char * etf_line;
 char * etf_version;
 lrc_map tree_properties;
 lrc_term term;
} etf_structure;

int lrc_term_store_etf(FILE * f, lrc_term t);

etf_structure load_etf(char *file_name);


#endif

typedef lrc_bool lrc_eb_match_function_tp(lrc_term,lrc_term,lrc_term);
typedef lrc_term lrc_eb_trafo_function_tp(lrc_term,lrc_term,lrc_term);

typedef struct trafo_entry {
  lrc_eb_trafo_function_tp *trafo_function;
} trafo_entry_tp, *trafo_table_tp;

typedef  struct binding_entry {
  lrc_eb_match_function_tp *match_function;
  int num_trafos;
  trafo_entry_tp *trafos;
} binding_entry_tp, *binding_table_tp;

void init_event_bindings(void);
void create_binding_table(int num_bind_constructs);
void define_binding(int bind_key, int num_trafos);
void set_binding_match_function(int bind_key, lrc_eb_match_function_tp match_function);
void set_binding_trafo_function(int bind_key, int trafo_key, lrc_eb_trafo_function_tp trafo_function);
int binding_num_trafos(int bind_key);
lrc_bool invoke_matcher(int bind_key, lrc_term event, lrc_term frame, lrc_term parameters);
lrc_term invoke_transformation(int bind_key, int trafo_key,
                               lrc_term event, lrc_term frame, lrc_term parameters);


lrc_term _lrc_add_bind(
   int binding_key, lrc_term match_parameters, lrc_term trafo_data, lrc_term instances);
lrc_term lrc_all_matches(lrc_term event, lrc_term frame, lrc_term instances);
int is_empty_bindings(lrc_term instances);


int instance_binding_number(lrc_term bi);
lrc_term instance_match_parameters(lrc_term bi);
lrc_term instance_trafo_data(lrc_term bi);
lrc_term bind_trafo_subtree_reference(lrc_term bt);
lrc_term bind_trafo_parameters(lrc_term bt);
int is_empty_trafo_data(lrc_term td_list);


void lrc_alloc_visit_table(int num_vprs, int num_vnts);
void lrc_define_visit(void f(), int global_number, int prod_number, int vis_number,
      int num_ip_attrs, int num_op_attrs);
void lrc_define_nont_visit(
  void vnt_routine(), int global_number,
  int nont_number, int visit_number, int num_ip, int num_op);

void lrc_define_packet_attr(
  int nont_number, int vis_num, char * attr_name, int packet_index, int is_input
);

char * lrc_attr_get_ip_name (int nt_num, int vnum, int packet_index);
char * lrc_attr_get_op_name (int nt_num, int vnum, int packet_index);
int    lrc_attr_get_ip_index(int nt_num, int vnum, char * attr_name);
int    lrc_attr_get_op_index(int nt_num, int vnum, char * attr_name);

int lrc_vpr_index(lrc_ptr f);

int lrc_prod_visnum_vpr_num(int prod, int vis_num);
lrc_ptr lrc_vpr_routine(int vpr_number);
int lrc_vpr_prod_number(int vpr_number);
int lrc_vpr_visit_number(int vpr_number);
int lrc_vpr_num_ip_attrs(int vpr_number);
int lrc_vpr_num_op_attrs(int vpr_number);

int lrc_prod_vnum_ip_size(int tag, int visit_number);
int lrc_prod_vnum_op_size(int tag, int visit_number);

int lrc_nont_visnum_vnt_num(int nont, int vis_num);
lrc_ptr lrc_vnt_routine(int vnt_number);
int lrc_vnt_nont_number(int vnt_number);
int lrc_vnt_visit_number(int vnt_number);
int lrc_vnt_num_ip_attrs(int vnt_number);
int lrc_vnt_num_op_attrs(int vnt_number);

lrc_term * lrc_create_ip(lrc_term t, int vnum);
lrc_term * lrc_create_op(lrc_term t, int vnum);

int lrc_visit_size(lrc_term t, int visit_number, int *ip_size, int *op_size);
lrc_term * lrc_visit_term_1(lrc_term t);
lrc_term * lrc_visit_term_with_attr_1(lrc_term t, lrc_term attr);
lrc_term * lrc_visit_term_with_attrs_1(lrc_term t, ...);

int lrc_visit_with_packets(int vis_num, lrc_term *ip, lrc_term *op);
lrc_term * lrc_visit_edse_root(lrc_term t,lrc_term bindings);

void set_packet_printing(void);
void unset_packet_printing(void);

void lrc_block_copy(lrc_term * dst, int d_offset, lrc_term *src, int s_offset, int num_terms);

/***
 *** WARNING THIS IS A GENERATED FILE.
 *** DO NOT EDIT THIS FILE!
 ***
 **/
typedef lrc_bool lrc_match_function_tp(lrc_term);
typedef lrc_term lrc_trafo_function_tp(lrc_term);
typedef struct lrc_string_list_elem * p_lrc_string_list;

typedef struct lrc_string_list_elem {
  p_lrc_string_list next;
  char * str;
} lrc_string_list;

int lrc_num_productions(void);
int lrc_num_constructors(void); /* Including wrapper constructors */

void lrc_define_nonterminal(
     char * ident, int global_number, int num_prods,
     int entry_tok, char * scan_state, char * entry_attr,
     int first_visit_ix, int num_visits
  );

void lrc_print_nont_info(int nt);
void lrc_print_prod_info(int prod);

void lrc_define_root(int);

int lrc_root_nonterminal(void);
int lrc_nont_num_prods(int nt);
int lrc_nont_entry_token(int);
char * lrc_nont_ident(int nt);
char * lrc_nont_scan_state(int nt);
int lrc_nont_first_visit_index(int);
int lrc_nont_num_visits(int);
int lrc_nont_first_prod(int nt);

int lrc_id_to_nont(char * nt_id);

void     lrc_nont_set_completing_term(int nt, lrc_term trm);
lrc_term lrc_nont_get_completing_term(int nt);
void     lrc_nont_set_placeholder_term(int nt, lrc_term trm);
lrc_term lrc_nont_get_placeholder_term(int nt);

void lrc_alloc_grammar_tables(int num_nonterminals, int num_productions, int num_wrappers);
void lrc_define_constructor(char * ident, int global_number, int num_sons, int lhs_nt);
void lrc_define_prod_visit_index(int prod, int vpr_num);
char * lrc_constructor_ident(int constructor_number);
int lrc_constructor_num_sons(int constructor_number);
int lrc_prod_next_prod(int constructor_number);
int lrc_prod_first_visit_index(int prod);
int lrc_prod_name_to_tag(char * ident);
int lrc_prod_lhs_nont(int);
int lrc_prod_num_visits(int);
void lrc_define_transformation(
  char * nt_id, char * tr_name, lrc_match_function_tp m_fun, lrc_trafo_function_tp tr_fun);

p_lrc_string_list lrc_strings_2(char * elem, p_lrc_string_list lst);
int               lrc_string_in_list(char * s, p_lrc_string_list strs);

p_lrc_string_list lrc_matching_transformations(lrc_term t);
lrc_term lrc_apply_transformation(lrc_term t, char * trafo_name);


typedef struct id   { char * ident; int id_code; } identifier_tp;
typedef struct nont { char * nont_id; }  nont_tp;
typedef struct prod { char * prod_id; short num_ntoccs; short first_ntocc; } prod_tp;
typedef struct nocc 
 { short number; short prod; short nont; short multiplicity; short is_nta; } nocc_tp;

typedef enum { INH, SYN, LOCAL } attr_kind_tp;
typedef struct attr { short ident_num;  attr_kind_tp kind; short prod_nont; } attr_tp;
typedef enum { AO_NORMAL, AO_LOCAL, AO_NTA_SR, AO_ANY } aocc_kind_tp;
/* kind AO_ANY is used in pattern matching; no aocc has this kind */
typedef struct aocc { aocc_kind_tp kind; short prod_ntocc; short attribute; short defining_eq; } aocc_tp;
typedef struct eq   { short destination; } eq_tp;

typedef struct ag_data {
  char * ag_name;
  int num_attr_idents;
  identifier_tp * ag_attr_idents;
  int       num_nonterminals;
  nont_tp * nonterminals;
  int       num_productions;
  prod_tp * productions;
  int       num_ntoccs;
  nocc_tp * ntoccs;
  int       num_attributes;
  attr_tp * attributes;
  int       num_aoccs;
  aocc_tp * aoccs;
  int       num_eqs;
  eq_tp   * eqs;
 } ag_rec_tp, * p_ag_rec_tp;


void allocate_attr_identifier_data(int num_idents);
void define_attr_ident(int ix, int id_code, char * s);
void print_attr_idents(void);
char * index_ident_table(int ix);
void allocate_nonterminal_data(int num_nts);
void allocate_production_data(int num_prods);
void allocate_ntocc_data(int num_noccs);
void allocate_attribute_data(int num_attrs);
void allocate_aocc_data(int num_aoccs);
void allocate_eq_data(int num_eqs);
void enter_nonterminal(int number, char * id);
void enter_production(char * id, int number, int num_ntoccs, int first_ntocc) ;
void enter_ntocc(int number, int prod, int nont, int multiplicity, int is_nta );
void enter_attribute(int ident_num, int number, int prod_nont, attr_kind_tp kind);
void enter_aocc_a(int number, int lntocc, int attr);
void enter_aocc_l(int number, int prod, int attr);
void enter_aocc_n(int number, int ntocc);
void enter_eq(int number, int destination);

int ag_num_productions(void);
int ag_num_nonterminals(void);
int ag_num_ntoccs(void);
int ag_num_attributes(void);
int ag_num_aoccs(void);
int ag_num_equations(void);

char *       nont_id(short nont);

short        ntocc_nont         (short ntocc);
short        ntocc_multiplicity (short ntocc);
short        ntocc_prod         (short ntocc);
char *       ntocc_id           (short ntocc);

char *       prod_id(short prod);
short        prod_num_ntoccs(short prod);
short        prod_first_ntocc(short prod);
short        prod_nth_ntocc(short prod, int n);

char *       attr_id  (short attr);
short        attr_nont(short attr);
short        attr_prod(short attr);
attr_kind_tp attr_kind(short attr);

aocc_kind_tp aocc_kind(short aocc);
int          aocc_is_nta (short aocc);
short        aocc_attr   (short aocc);
short        aocc_nocc   (short aocc);
short        aocc_prod   (short aocc);

short        eq_destination(short eq);
short        aocc_defining_eq(short aocc);

void ag_print_prod(short prod);
void ag_print_aocc(short aocc);
void ag_print_equations(void);
int ag_check_tables(void);



char * lrc_locate_dir(char ** search_path, char ** file_names);
int lrc_read_ag_tables(char ** search_path);

typedef struct aocc_pattern {
  aocc_kind_tp kind;
  char * prod_id;
  char * nt_id;
  int multiplicity;
  char * attr_id;
} aocc_pattern_tp;

void print_aocc_pattern(aocc_pattern_tp pat);
aocc_pattern_tp string_to_aocc_pattern(char * s);
int aocc_matches_pattern(int aocc, aocc_pattern_tp pat);
void print_matching_equations(aocc_pattern_tp pat);

#define EQ_TRACE_NONE '\0'
#define EQ_TRACE_PRINT 'P'

void allocate_eq_trace_data(int num_eqs);
void eq_set_trace_status(int eq, char status);
char eq_trace_status(int eq);
void eqs_set_print_matching(aocc_pattern_tp pat);
void eqs_set_tracing(char * pattern);
char eq_trace_status(int aocc);

#ifndef H_REFERENCE
#define H_REFERENCE
struct path_element {
  /* int tag; */
  int childnumber;
  struct path_element * next;
};
typedef struct path_element PathElement;
typedef PathElement * Path;

typedef struct path_pair {
  Path first;
  Path second;
}  PathPair;

typedef enum {
  REF_SUBTREE,
  REF_SUBLIST
} teReferenceKind;

typedef struct reference {
  lrc_term tree;
  teReferenceKind kind;
  Path  sub0;
  Path  sub1;
} * Reference;

Path            path_extend(Path,int);
Path            path_remove_deepest(Path,int);
void            path_print(Path);
int             path_num_edges(Path);
int             path_equal(Path,Path);
int             path_is_ancestor(Path,Path);
Path            path_common_ancestor(Path,Path);
Path            path_take(Path,int);
Path            path_clip(Path, Path);
lrc_term        path_map_to_term(lrc_term,Path);
lrc_term        path_deref_length(lrc_term,Path,int);
Path            path_copy(Path);
int             path_is_root_path(Path);
int      path_is_singleton(Path p);
Path     create_root_path(lrc_term t);
Path     path_concat(Path p1, Path p2);
Path     term_map_to_path(lrc_term root,lrc_term t);

Reference new_reference();
int references_overlap(int num_refs, Reference * refs);
Reference term_to_reference(lrc_term root, lrc_term t);
Reference create_root_reference(lrc_term root);
Reference reference_deref(Reference r);
Reference term_to_reference(lrc_term root, lrc_term t);
Reference subterm_to_reference(lrc_term t);
lrc_term reference_to_term(Reference r);


#endif

typedef enum {
  unparse_open_command,
  unparse_child_command,
  unparse_skip_child_command,
  unparse_attr_command,
  unparse_str_command,
  unparse_chain_command_start,
  unparse_chain_command_end
} unparse_command_tp;

typedef struct {
  unparse_command_tp command;
  char * command_data;
} unparse_commands_entry_tp;

typedef unparse_commands_entry_tp unparse_commands_tp[];
typedef enum {
  view_entry_default,
  view_entry_normal,
  view_entry_list
} view_table_kind_tp;

typedef struct {
  view_table_kind_tp kind;
  int first_command_index;
  int num_commands;
} view_table_entry_tp;

typedef view_table_entry_tp view_prod_table_tp[];

typedef struct {
  char * view_name;
  view_prod_table_tp  * view_prod_table;
  unparse_commands_tp * view_unparse_commands;
} lrc_views_entry_tp;

typedef lrc_views_entry_tp lrc_views_tp[];

void unparse_term(lrc_term t, char * view_name, void printer(char *));


void f_unparse_term_with_attributes(FILE *f, lrc_term trm, char * view_name, lrc_term uals);
void unparse_term_with_attributes(lrc_term trm, char * view_name, lrc_term uals);



lrc_views_entry_tp lrc_view_data(char * view_name);
int lrc_view_exists(char * view_name);
int lrc_prod_first_command_index(lrc_views_entry_tp view_rec, int prod);
int lrc_prod_num_commands(lrc_views_entry_tp view_rec, int prod);
unparse_commands_entry_tp
    lrc_prod_nth_command(lrc_views_entry_tp view_rec, int prod, int command_num);
int lrc_prod_has_unparsing(lrc_views_entry_tp view_rec, int prod);
int lrc_prod_lhs_is_rp(lrc_views_entry_tp view_rec, int prod);
int lrc_view_prod_lhs_is_rp(char * view_name, int prod);
int lrc_prod_child_is_rp(lrc_views_entry_tp view_rec, int prod, int son_num);


#ifndef H_STYLE_EDITOR
#define H_STYLE_EDITOR
typedef lrc_map Properties;

typedef struct style {
  lrc_string name;
  Properties properties;  
} * Style;

typedef struct style_list {
  struct style_list * next;
  Style element;
} * StyleList;

StyleList add_style(Style head, StyleList l);
Style     get_style(lrc_string style_name, StyleList lst);

Style      style_create(lrc_string name);
void       style_define_property(Style st, lrc_string prop, lrc_string value);
int        style_contains(Style st, lrc_string prop_name);
lrc_string style_lookup(Style st, lrc_string prop_name);
lrc_string style_lookup_str_default(Style st, lrc_string search_key, lrc_string deflt);
int        style_lookup_int(Style st, lrc_string search_key);
int        style_lookup_int_default(Style st, lrc_string search_key, int deflt);

Style style_read_from_file(char * style_name, char * fname);

#endif

#ifndef H_FRAGMENTS
#define H_FRAGMENTS
typedef enum {
  NO_FRAGMENT=0,
  CHILD_FRAGMENT,
  UP_FRAGMENT,
  INDENT_UP_FRAGMENT,
  INDENT_DOWN_FRAGMENT,
  OPEN_GROUP_FRAGMENT,
  CLOSE_GROUP_FRAGMENT,
  ORIGIN_FRAGMENT,
  PUSH_STYLE_FRAGMENT,
  POP_STYLE_FRAGMENT,
  SET_INDENT_FRAGMENT,
  ENTER_ATTR_FRAGMENT,
  TEMPLATE_STR_REF_FRAGMENT,
  TREE_STR_REF_FRAGMENT,
  TREE_CHAR_FRAGMENT,
  CONSTANT_STR_FRAGMENT,
  HARD_NL_FRAGMENT,
  OPTIONAL_NL_FRAGMENT,
  CONDITIONAL_NL_FRAGMENT,
  CHAR_FRAGMENT
} UnparseElementKind;

typedef struct template_string_ref {
  int template_index; /* index in an template table */
  short int offset;  /* offset of first character in string */
  short int num_chars; /* number of characters in string */
} TemplateStringRef;

typedef struct tree_string_ref {
  lrc_term term;
  short int offset;  /* offset of first character in string */
  short int num_chars; /* number of characters in string */
} TreeStringRef;

typedef struct unparse_element {
  UnparseElementKind kind;
  union {
    TemplateStringRef tmpl_sr;
    TreeStringRef     tree_sr;
    lrc_term          term;
    lrc_string        string;
    char              ch;
    int               i;
  } element_data;
  
} UnparseElement;



typedef UnparseElement * UnparseBlock;

typedef struct unparse_block_header {
   struct unparse_block_header * next;
   struct unparse_block_header * prev;
   int num_elements;
   int free_index;
   UnparseBlock elements;
} *UnparseBlockHeader;

typedef struct fragments {
   UnparseBlockHeader first;
   UnparseBlockHeader last;
} * Fragments;

typedef struct unparse_stack_element {
  struct unparse_stack_element * below;
  int indentation;
  lrc_string indentation_string;
} UnparseStackElement, * UnparseStack;


typedef struct unparse_element_ref {
  Fragments f;
  UnparseBlockHeader block;
  int index;
} UnparseElementReference;

typedef struct unparse_range {
  UnparseElementReference start;
  UnparseElementReference end;
} UnparseRange;

#define HAS_SCREEN_REPR(k) ((k)>ENTER_ATTR_FRAGMENT)

#define TEMPLATE_STR_REF(e) e.element_data.tmpl_sr
#define TREE_STRING_REF(e) e.element_data.tree_sr
#define STRING(e) e.element_data.string
#define CHAR(e) e.element_data.ch
#define INT(e) e.element_data.i
#define TERM(e) e.element_data.term

#define MIN_UNPARSE_BLOCK_SIZE 1000

#define FREE_INDEX(f) f->last->free_index
#define FREE_ELEMENT(f) f->last->elements[FREE_INDEX(f)]
#define FREE_DATA(f) FREE_ELEMENT(f).element_data
#define BUMP(f)  FREE_INDEX(f)=FREE_INDEX(f)+1

void print_unparse_element(UnparseElement e, unparse_commands_tp * commands);

void fragments_print_block_info(Fragments f);


UnparseStack push_unparse(int indentation, UnparseStack us);
UnparseStack pop_unparse(UnparseStack us);


Fragments create_fragments(void);
void fragments_delete_elements(Fragments fr);

void fragments_all_elements(Fragments f,  void action());

void fr_add_template_substring(int template_index, int char_offset, int length, Fragments f);
void fr_add_tree_substring(lrc_term t, int char_offset, int length, Fragments f);
void fr_add_tree_char(lrc_term t, Fragments f);
void fr_add_constant_string(char * str, Fragments f);
void fr_add_indent_up(Fragments f);
void fr_add_indent_down(Fragments f);
void fr_add_set_indent(Fragments f);
void fr_add_line_break(Fragments f);
void fr_add_optional_line_break(Fragments f);
void fr_add_consistent_line_break(Fragments f);
void fr_add_open_group(Fragments f);
void fr_add_close_group(Fragments f);
void fr_add_constant_char(char c, Fragments f);
void fr_add_push_style(char * style_name, int style_name_length, Fragments f);
void fr_add_pop_style(Fragments f);
void fr_add_tree_str(lrc_term t, Fragments f);
void fr_add_origin(lrc_term t, Fragments f);
void fr_add_child(int n, Fragments f);
void fr_add_up(Fragments f);
void fr_add_enter_attr(Fragments f);

PathPair fragments_range_to_path(Fragments fr, Range screen_range);

Range path_to_screen_range(Fragments f, Path P);


#endif

#ifndef H_VIEWS
#define H_VIEWS
typedef struct text_block {
  struct text_block * next;
  struct text_block * prev;
  Textbuffer text_buffer;
} * TextBlock;

typedef struct {
  TextBlock first;
  TextBlock second;
} TextBlockPair;

typedef struct {
  TextBlock first;
  TextBlock last;
} * TextPieces;

typedef struct view_instance {
  Reference term_ref;   /* reference to the subterm or attribute */
  lrc_term attributes;  /* attributes in the unparsing */
  lrc_views_entry_tp view_table; /* the table with view-entries */
  Fragments fragments; /* the unparse fragments */
} *ViewInstance;

ViewInstance create_view_instance(void);

void vi_clear_unparsing(ViewInstance vi);

void vi_set_attributes(ViewInstance vi, lrc_term attrs);
void vi_set_view(ViewInstance vi, lrc_views_entry_tp table);
char * vi_get_view_name(ViewInstance vi);

void vi_enter_term(ViewInstance vi, lrc_term t);
Reference vi_get_reference(ViewInstance vi);

void vi_compute_fragments(ViewInstance vi);

void vi_print(ViewInstance vi);

#endif

#ifndef H_DECORATION
#define H_DECORATION
typedef enum { NO_AST, NEW_BORN_AST, SAME_AS_PREV_AST, DIFF_FROM_PREV_AST } ast_state_tp;

typedef struct decorated_term {
  lrc_term ast;
  ast_state_tp ast_state;
  lrc_term * decoration;
  lrc_term derived_bindings;
} * DecoratedTerm;

DecoratedTerm create_decorated_term(void);
void          dt_enter_ast(DecoratedTerm dt, lrc_term abstract_tree);
lrc_term      dt_edse_initial_ast(DecoratedTerm dt);
void          dt_decorate_term(DecoratedTerm dt);
lrc_term *    dt_get_decoration(DecoratedTerm dt);
void          dt_install_root_attr(DecoratedTerm dt,lrc_term ast, lrc_term root_attr, char * name);

#endif

#ifndef H_UNPARSER
#define H_UNPARSER
typedef enum {
   os_plain, os_after_percent, os_after_ps, os_after_pso
} output_state_tp;

typedef struct unparse_descriptor {
  lrc_term   term;       /* The term that must be unparsed */
  lrc_term   uat;        /* The attributes in the the unparsing of term */
  lrc_string view_name;  /* The name of the textual view */
} UnparseDescriptor;


void unparser_install_attributes(lrc_term ual, char * name);

void unparser_init_text_styles(void);
void unparser_add_style(Style st);
StyleList unparser_get_text_styles(void);
Style unparser_obtain_text_style(lrc_string style_name);

int vi_create_fragments(ViewInstance vi);


ViewInstance unparse_descriptor_to_vi(UnparseDescriptor ud);


void init_unparser(void);

lrc_term uat_apply_path(lrc_term uat, Path p);

UnparseDescriptor dt_sr_view2unparse_descriptor
( DecoratedTerm dt,
  Reference ref,
  lrc_string view_name
);

#endif

#ifndef H_TEXT_UNPARSER
#define H_TEXT_UNPARSER
void unparse_to_file_stream(UnparseDescriptor ud, FILE * f);
void unparse_to_file(UnparseDescriptor ud, lrc_string file_name);
void fragments_to_file_stream(ViewInstance vi, FILE *f);

#endif

#ifndef H_SURGERY
#define H_SURGERY
typedef struct replacement_descriptions {
  lrc_term    term;
  int         num_repl;
  Reference * operands;
  lrc_term  * replacements;
} * Replacement;

Replacement create_replacement(lrc_term t, int num_repl);

lrc_term multi_replace(
  lrc_term ast, int num_repl, Reference * operands, lrc_term * replacements);

lrc_term in_situ_replace(lrc_term t, Path path, lrc_term replacement);
lrc_term in_situ_multi_replace(
  lrc_term ast,
  Replacement replacement
);


#endif

#ifndef H_BINDING_EVENT
#define H_BINDING_EVENT
typedef enum { 
  EH_ERROR, EH_NOT_HANDLED, EH_REQUIRE_REPLACEMENT, EH_FULLY_HANDLED
} E_HANDLING_RESULT;

typedef struct eh_result {
  E_HANDLING_RESULT result_code;
  union {
    char *      mess;        /* error message */
    Replacement replacement; /* requested replacement */
  } result_value;
} EventHandlingResult;

int dt_handle_abstract_event(DecoratedTerm dt, lrc_term event, lrc_term frame);


#define NOT_CHANGED_TREE 0
#define CHANGED_TREE 1
#define NOT_HANDLED  0 
#define PARTIALLY_HANDLED (1<<1)
#define FULLY_HANDLED (1<<2)

#endif

#endif
