/*
** attrs.c
** april 1994 by Maarten Pennings
** Library functions by Matthijs Kuiper
*/

#include <stdio.h>
#include "attrs.h"

static lrc_term_ix index_attr(lrc_attr a) {
  return abs((int)a+T__Attr)%lrc_term_tabelsize;
}

static lrc_bool eq_attr(lrc_term t,lrc_attr b) {
  return LRC_TAG(t)==FIELD(b,0,int) && 
         LRC_VALUE(t,lrc_attr)==FIELD(b,sizeof(lrc_ptr),lrc_attr);
}

lrc_term C_Attr(lrc_attr a) {
  struct {lrc_attr tag;lrc_attr a;} buf;
  buf.tag=(lrc_attr)T__Attr; buf.a=a;
  /*** 
    if (a!=0) printf("SHOULD NOT OCCUR: non-NULL attr!\n");
   ***/
  return lrc_shared_prim(index_attr(a),eq_attr,sizeof(buf),&buf);
}



/*********************\
** Library functions **
\*********************/

int lrc_attr_compare(lrc_attr a, lrc_attr b) {
  return ((int)a<(int)b) ? lrc_less : ((a==b)?lrc_equal:lrc_greater);
}

int lrc_attr_compare_term(lrc_term a, lrc_term b) {
  return lrc_attr_compare(LRC_VALUE_lrc_attr(a),LRC_VALUE_lrc_attr(b));
}

lrc_bool lrc_attr_equal(lrc_attr a, lrc_attr b) {
  return (a==b);
}

lrc_bool lrc_attr_equal_term(lrc_term a, lrc_term b) {
  return lrc_attr_equal(LRC_VALUE_lrc_attr(a),LRC_VALUE_lrc_attr(b));
}

const lrc_attr lrc_nil_attr=0;
