/*
** avl.h
** april 1994 by Maarten Pennings
** Generated from headers.noweb
** Original by Matthijs Kuiper (generated, then hand-changed)
*/

#include "lrcmemory.h"
#define ALLOC_AVL(n) lrc_malloc(n)
#define FREE_AVL(p) lrc_free(p)
#include "shalloc.h"

typedef struct rec_AVL *AVL_tp;

typedef struct rec_AVL {
  int height;
  int hash;
  AVL_tp left;
  lrc_term key;
  lrc_term value;
  AVL_tp right;
} rec_AVL;

typedef int compare_function_tp();
typedef lrc_bool equal_function_tp();

  AVL_tp avl_empty(void);
     int avl_lookup(lrc_term *, lrc_term, AVL_tp,compare_function_tp);
  AVL_tp avl_insert (lrc_term, lrc_term, AVL_tp,compare_function_tp);
     int avl_num_elements(AVL_tp);
lrc_bool avl_equal(AVL_tp t1, AVL_tp t2
                  ,equal_function_tp eq_key, equal_function_tp eq_value);
     int avl_compare(AVL_tp,AVL_tp
                    ,equal_function_tp,compare_function_tp
                    ,equal_function_tp,compare_function_tp);
  AVL_tp avl_update(AVL_tp t1, AVL_tp t2, compare_function_tp comparer);
    void avl_print(AVL_tp a, void print_key(), void print_value());
     int avl_hash(AVL_tp avl);

    void avl_forall(AVL_tp a, void action());
    void avl_forall_keys(AVL_tp a, void action());
    void mark_avl(AVL_tp a);

