/*
** foreign.c
** march 1994 by Maarten Pennings
** original by Matthijs Kuiper
*/

#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "foreign.h"


/******************\
** char functions **
\******************/

int CHARtoINT(char c) { 
  return (int)c; 
}


/*****************\
** int functions **
\*****************/

int Min(const int a, const int b) {
    return a<b ? a : b;
}

int Max(const int a, const int b) {
    return a<b ? b : a;
}

char INTtoCHAR(int i) { 
  return (char)i; 
}

lrc_real INTtoREAL(int i) { 
  return i; /* zie pagina 29 van `C leerboek' */
}

lrc_string INTtoSTR(int i) { 
   lrc_string res = (lrc_string)ALLOC_STR(20);
   sprintf(res,"%d",i);
   return res;
}


/******************\
** real functions **
\******************/

int REALtoINT(lrc_real r) { 
  return r; /* zie pagina 33 van `C leerboek' */
}

lrc_string REALtoSTR(lrc_real r) {
   lrc_string res = (lrc_string)ALLOC_STR(40);
   *res='\0';
   sprintf(res,"%0g",r);
   return res;
}


/*****************\
** str functions **
\*****************/

lrc_string STRtolower(lrc_string s) {
  int ix;
  int len=strlen(s);
  lrc_string res=(lrc_string)ALLOC_STR(strlen(s)+1);
  for(ix=0;ix<len;ix++) res[ix]=tolower(s[ix]);
  res[len]='\0';
  return res;
}

lrc_string STRtoupper(lrc_string s) {
  int ix;
  int len=strlen(s);
  lrc_string res=(lrc_string)ALLOC_STR(strlen(s)+1);
  for(ix=0;ix<len;ix++) res[ix]=toupper(s[ix]);
  res[len]='\0';
  return res;
}

int STRlen(lrc_string s) {
  return strlen(s);
}

int STRtoINT(lrc_string s) { 
  return strtol(s,NULL,0); 
}

lrc_real STRtoREAL(lrc_string s) { 
  return strtod(s,NULL); 
}

int STRindex(lrc_string s,char c) {
   lrc_string tmp=s;
   int pos=1;
   while (*tmp && *tmp!=c) {pos++; tmp++; }
   return pos;
}

lrc_string repeatCHAR(char c,int i) {
   int ix;
   lrc_string res = (lrc_string)ALLOC_STR(i+1);
   for(ix=0;ix<i;ix++) res[ix]=c; res[i]=0;
   return res;
}

/*****************\
** ptr functions **
\*****************/

lrc_string PTRtoSTR(lrc_ptr p) { 
   lrc_string res = (lrc_string)ALLOC_STR(9);
   sprintf(res,"%p",p);
   return res;
}


