#ifdef LRC_GC
# include <gc.h>
# define _lrc_malloc(n) GC_malloc(n)
# define _lrc_calloc(m,n) GC_malloc((m)*(n))
# define _lrc_free(p) GC_free(p)
# define _lrc_realloc(p,s) GC_realloc(p,s)
# define _ALLOC_STR(n) GC_malloc_atomic(n)
#else
/* include <malloc.h>  */
# define _lrc_malloc(n) malloc(n)
# define _lrc_calloc(m,n) calloc(m,n)
# define _lrc_free(p) free(p)
# define _lrc_realloc(p,x) realloc(p,s)
# define _ALLOC_STR(n) lrc_malloc(n)
#endif

#include <stdlib.h>
#include <stdio.h>
#include "lrcmemory.h"

static int allow_free=0;
static int num_allocated=0;
static int max_allocated=0;

int num_allocated_bytes() {
  return num_allocated;
}

static void update_allocated(size_t s) {
  num_allocated+=s;
  if (s>max_allocated) { 
    max_allocated=s;
    printf("NEW MAX SIZE=%d\n",max_allocated); fflush(stdout);
  }
  if ((num_allocated % 1000000)==0) {
    printf("ANOTHER MILLION BYTES; #allocated=%d\n", num_allocated); fflush(stdout);
  }
}

void * lrc_malloc(size_t s) {
  void *res;
  /** update_allocated(s); **/
  res=_lrc_malloc(s);
  if (res==0) { printf("lrc_malloc failed !?!?!\n"); fflush(stdout); }
  return res;
}

void * lrc_calloc(size_t n, size_t m) {
  return _lrc_calloc(n,m);
}

void lrc_free(void * p) {
  if (allow_free) _lrc_free(p);
}

void * lrc_realloc(void *p, size_t s) {
  /* update_allocated(s); */
  return _lrc_realloc(p,s);
}

void * ALLOC_STR(size_t n) {
  return _ALLOC_STR(n);
}

