/*
** memo.h
** february 1994 Maarten Pennings
** Generated from memo.nw
*/



typedef int lrc_memo_index;

#undef WRITE_RUNTIME_STRATEGY
#undef COMP_STATISTICS

/*
** Definition of the Lookup Technique:
**    OLDEST_YOUNGEST_NEW, YOUNGEST_OLDEST_NEW,
**    YOUNGEST_NEW_OLDEST or OLDEST_ALLYOUNGER_NEW,
*/
#undef    OLDEST_NEW_YOUNGEST
#undef    YOUNGEST_OLDEST_NEW
#undef    NEW_YOUNGEST_OLDEST
#define   NEW_OLDEST_YOUNGEST

/* A prime p that can not be written as (2^k)-1
** some primes 11,101,1009,10007,100003
*/
#define lrc_memo_tablesize 10007

#define MAX_NUMB_ENTRIES_PER_BUCKET 4

typedef lrc_term lrc_packet;
typedef void (*lrc_visfun)(lrc_packet,lrc_packet);

extern void lrc_memo_strategy_config (int,int,int);
extern void lrc_memo_tree_size_config (int,int);
extern void lrc_memo_init();
extern void lrc_memo_start_AE();
extern void lrc_memo_end_AE();


extern int lrc_memo(lrc_visfun f,int ipsize,lrc_packet ip,
                                 int opsize,lrc_packet op);

#define LRC_MEMOS(f,ip,op) lrc_memo(f,sizeof(ip),(lrc_packet)(&ip), sizeof(op),(lrc_packet)(&op))
#define LRC_MEMOP(f,ip,op) lrc_memo(f,sizeof(*ip),(lrc_packet)(ip),sizeof(*op),(lrc_packet)(op))


/***************\
** Diagnostics **
\***************/

int  lrc_memo_time();


       int lrc_memo_hits(lrc_cell);
       int lrc_memo_birth(lrc_cell);
lrc_visfun lrc_memo_visfun(lrc_cell);

typedef void lrc_memo_printer(lrc_cell);
typedef lrc_bool lrc_memo_filter(lrc_cell);

void lrc_memo_dump_set_birth_time(int);
void lrc_memo_dump(lrc_memo_filter,lrc_memo_printer);
void lrc_memo_stats(int level);

#define CELL_ADMIN_SIZE   4
#define USER_CELL(c)      (c+CELL_ADMIN_SIZE)



