#ifndef _LRCLIB_INCLUDED
#define _LRCLIB_INCLUDED
/*
** lrclib.h
** 
** DO NOT CHANGE THIS FILE.
** THIS FILE IS GENERATED FROM headers.noweb
**
*/

#define LRC_LIB_VERSION "BASE;INITIAL TERMS"

#include <stdio.h>
#define FAT


#include <stddef.h>


/* memory management */
void * lrc_malloc(size_t s);
void * lrc_calloc(size_t n, size_t m);
void lrc_free(void * p);
void * lrc_realloc(void * p, size_t s);
void * ALLOC_STR(size_t n);




/* basics */
typedef int   lrc_bool;
typedef void *lrc_ptr;

extern const lrc_bool lrc_true;
extern const lrc_bool lrc_false;

extern const int lrc_less;
extern const int lrc_equal;
extern const int lrc_greater;



/* shalloc */
/* A prime p that can not be written as (2^k)-1 
** some primes 11,101,1009,10007,100003 */
#define lrc_term_tabelsize 100003

typedef unsigned int lrc_term_ix;

#define FIELD(buf,offset,type)   (*(type*)((int)(buf)+offset))

typedef lrc_ptr *lrc_term;
#ifdef FAT
#define LRC_USER_FIELDS_OFFSET 6
#else
#define LRC_USER_FIELDS_OFFSET 3
#endif
#define LRC_USER_DATA(term) ((term)+LRC_USER_FIELDS_OFFSET)
#define LRC_USER_FIELD(typ,term,fnum) ((typ)((term)[LRC_USER_FIELDS_OFFSET+fnum]))
#define LRC_TAG(t)            LRC_USER_FIELD(int,t,0)
#define LRC_CHILD(t,i)        LRC_USER_FIELD(lrc_term,t,i)

#define LRC_ADDRESS_PRIMITIVE(term) ((lrc_term)(term)+1+LRC_USER_FIELDS_OFFSET)
#define LRC_VALUE_GENERAL(term,type)  (*(type*)(LRC_ADDRESS_PRIMITIVE(term)))

#define LRC_VALUE_int(t) LRC_VALUE_GENERAL(t,int)
#define LRC_VALUE_char(t) LRC_VALUE_GENERAL(t,char)
#define LRC_VALUE_lrc_bool(t) LRC_VALUE_GENERAL(t,lrc_bool)
#define LRC_VALUE_lrc_string(t) LRC_VALUE_GENERAL(t,lrc_string)
#define LRC_VALUE_lrc_map(t) LRC_VALUE_GENERAL(t,lrc_map)
#define LRC_VALUE_lrc_attr(t) LRC_VALUE_GENERAL(t,lrc_attr)
/* #define LRC_VALUE_lrc_ptr(t) LRC_VALUE_GENERAL(t,lrc_ptr) */
#define LRC_VALUE_lrc_ptr(t) t

#define LRC_VALUE_lrc_real(t) lrc_value_real(t)

#define LRC_VALUE(t,type)     LRC_VALUE_ ## type(t)

void lrc_all_terms_in_cache(void action(lrc_term));

void remove_unmarked_terms(void);

#ifdef TRACE
void define_term_tracer(void tracer());
#endif
 
void lrc_term_register_hit(lrc_ptr); 
typedef lrc_bool lrc_comparer(lrc_term,lrc_ptr);
lrc_term lrc_shared_prim(lrc_term_ix i,lrc_comparer eq,int size,lrc_ptr buf);

lrc_term lrc_shared_cons(int size,lrc_term buf);


lrc_term lrc_term0(int);
lrc_term lrc_term1(int,lrc_term);
lrc_term lrc_term2(int,lrc_term,lrc_term);
lrc_term lrc_term3(int,lrc_term,lrc_term,lrc_term);
lrc_term lrc_term4(int,lrc_term,lrc_term,lrc_term,lrc_term);
lrc_term lrc_term5(int,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term);
lrc_term lrc_term6(int,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term);
lrc_term lrc_term7(int,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term);
lrc_term lrc_term8(int,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term);
lrc_term lrc_term9(
   int,
   lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term);
lrc_term lrc_term10(
   int,
   lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term,lrc_term);
lrc_term lrc_termhuge(int,...);

lrc_term lrc_build_term(char *,...);

void mark_term(lrc_term t);


/* ints 0 */
#define T__Int 0

  lrc_term C_Int(int);
       int lrc_int_compare(int,int);
       int lrc_int_compare_term(lrc_term, lrc_term);
  lrc_bool lrc_int_equal(int,int);
  lrc_bool lrc_int_equal_term(lrc_term, lrc_term);
       int lrc_int_default(void);


/* bools 1 */
#define T__Bool 1

lrc_term C_Bool(lrc_bool);
     int lrc_bool_compare(lrc_bool,lrc_bool);
     int lrc_bool_compare_term(lrc_term, lrc_term);
lrc_bool lrc_bool_equal(lrc_bool,lrc_bool);
lrc_bool lrc_bool_equal_term(lrc_term, lrc_term);
lrc_bool lrc_bool_default(void);

/* chars 2 */
#define T__Char 2

lrc_term C_Char(char);
     int lrc_char_compare(char,char);
     int lrc_char_compare_term(lrc_term, lrc_term);
lrc_bool lrc_char_equal(char,char);
lrc_bool lrc_char_equal_term(lrc_term, lrc_term);
    void lrc_char_fprint(FILE * f, char c);
    void lrc_char_print(char);
    char lrc_char_default(void);

/* reals 3 */
typedef double lrc_real; 

#define T__Real 3

  lrc_term C_Real(lrc_real);
       int lrc_real_compare(lrc_real,lrc_real);
       int lrc_real_compare_term(lrc_term, lrc_term);
  lrc_real lrc_value_real(lrc_term);
  lrc_bool lrc_real_equal(lrc_real,lrc_real);
  lrc_bool lrc_real_equal_term(lrc_term, lrc_term);
  lrc_real lrc_real_default(void);

/* strs 4 */
typedef char * lrc_string; 

#define T__Str 4

  lrc_term C_Str(lrc_string);
       int lrc_string_compare(lrc_string,lrc_string);
       int lrc_string_compare_term(lrc_term, lrc_term);
  lrc_bool lrc_string_equal(lrc_string,lrc_string);
  lrc_bool lrc_string_equal_term(lrc_term, lrc_term);
      void lrc_string_print(lrc_string);

lrc_string lrc_string_const(lrc_string);
lrc_string lrc_string_concat(lrc_string,lrc_string);
lrc_string lrc_vstring_concat(lrc_string,...);
lrc_string lrc_string_sub(lrc_string,int,int);
lrc_string lrc_string_opensub(lrc_string,int);
      char lrc_string_index(lrc_string,int);

lrc_string lrc_string_default(void);

lrc_string lrc_string_copy(lrc_string);


/* toks 5 */
#define T__Tok 5
#define C_Tok(t) C_Str(t)


/* ptrs 6 */
#define T__Ptr 6

  lrc_term C_Ptr(lrc_ptr);
       int lrc_ptr_compare(lrc_ptr, lrc_ptr);
       int lrc_ptr_compare_term(lrc_term, lrc_term);
  lrc_bool lrc_ptr_equal(lrc_ptr, lrc_ptr);
  lrc_bool lrc_ptr_equal_term(lrc_term, lrc_term);

    extern const lrc_ptr lrc_nil;
   lrc_ptr lrc_ptr_default(void);

/* maps 7 */
typedef struct rec_AVL *AVL_tp;

typedef struct rec_AVL {
  int height;
  int hash;
  AVL_tp left;
  lrc_term key;
  lrc_term value;
  AVL_tp right;
} rec_AVL;

typedef int compare_function_tp();
typedef lrc_bool equal_function_tp();

typedef struct lrc_map {
  lrc_term              default_value;
  AVL_tp                avl;
  equal_function_tp   * equal_key;
  compare_function_tp * compare_key;
  equal_function_tp   * equal_value;
  compare_function_tp * compare_value;
} lrc_map;

#define T__Map 7

  lrc_term C_Map(lrc_map);
       int lrc_map_compare(lrc_map, lrc_map); 
       int lrc_map_compare_term(lrc_term, lrc_term); 
  lrc_bool lrc_map_equal(lrc_map, lrc_map);
  lrc_bool lrc_map_equal_term(lrc_term, lrc_term);
      void lrc_map_print(lrc_map, void print_key(), void print_value());
      void mark_map(lrc_term);

extern lrc_map lrc_empty_map(
      equal_function_tp *,
      compare_function_tp *,
      equal_function_tp *,
      compare_function_tp *,
      lrc_term
   );

  lrc_term lrc_map_application  (lrc_term, lrc_map);
  lrc_bool lrc_map_in           (lrc_term, lrc_map);
   lrc_map lrc_map_single_update(lrc_term, lrc_term, lrc_map);
   lrc_map lrc_map_update       (lrc_map,  lrc_map);
   lrc_map lrc_map_init         (lrc_map,  lrc_term, int);

      void map_forall(lrc_map m, void action());
      void map_forall_keys(lrc_map m, void action());
       int map_num_keys(lrc_map m);


/* attrs 8 */
typedef lrc_ptr lrc_attr; 

#define T__Attr 8

  lrc_term C_Attr(lrc_attr);
       int lrc_attr_compare(lrc_attr, lrc_attr);
       int lrc_attr_compare_term(lrc_term, lrc_term);
  lrc_bool lrc_attr_equal(lrc_attr, lrc_attr);
  lrc_bool lrc_attr_equal_term(lrc_term, lrc_term);

    extern const lrc_attr lrc_nil_attr;


/* memo */
typedef lrc_term lrc_packet;
typedef void (*lrc_visfun)(lrc_packet,lrc_packet);

extern int lrc_memo(lrc_visfun f,int ipsize,lrc_packet ip,int opsize,lrc_packet op);

#define LRC_MEMOS(f,ip,op) lrc_memo(f,sizeof(ip),(lrc_packet)(&ip),\
                                      sizeof(op),(lrc_packet)(&op))
#define LRC_MEMOP(f,ip,op) lrc_memo(f,sizeof(*ip),(lrc_packet)(ip),\
                                      sizeof(*op),(lrc_packet)(op))

extern void lrc_memo_strategy_config (int,int,int);
extern void lrc_memo_tree_size_config (int,int);
extern void lrc_memo_init(void);
extern void lrc_memo_start_AE(void);
extern void lrc_memo_end_AE(void);


extern void lrc_memo_statistics(int * num_allocs, int * num_hits);





/* prims */
#define lrc_first_free_tag 9

void lrc_lib_init(void);
void lrc_lib_mark(void);
lrc_term lrc_list_append(int empty_tag, lrc_term l1, lrc_term l2);
#define lrc_ident(x) (x)

int LrcCompareTrees(lrc_term,lrc_term);
int lrc_primitive_compare(lrc_term, lrc_term);

int lrc_term_equal(lrc_term, lrc_term);

/* foreign */
       int CHARtoINT(char);

       int Min(const int,const int);
       int Max(const int,const int);
  lrc_real INTtoREAL(int);
      char INTtoCHAR(int);
lrc_string INTtoSTR(int);

       int REALtoINT(lrc_real);
lrc_string REALtoSTR(lrc_real);

lrc_string STRtolower(lrc_string);
lrc_string STRtoupper(lrc_string);
       int STRlen(lrc_string);
       int STRtoINT(lrc_string);
  lrc_real STRtoREAL(lrc_string);
       int STRindex(lrc_string,char);
lrc_string repeatCHAR(char,int);

lrc_string PTRtoSTR(lrc_ptr);

/*
** Diagnostics
** from shalloc/memo/prims
*/
int  lrc_term_time(void);

int lrc_term_hashix(lrc_term);
int lrc_term_hits(lrc_term);
int lrc_term_birth(lrc_term);
int lrc_term_nnodes(lrc_term t);
int lrc_term_size(lrc_term t);
int lrc_term_occupied_size(lrc_term t);
int lrc_term_mark(lrc_term t);

typedef void lrc_term_printer(lrc_term);
typedef lrc_bool lrc_term_filter(lrc_term);

void lrc_term_dump_set_birth_time(int);
void lrc_term_dump(lrc_term_filter,lrc_term_printer);
void lrc_term_stats(int level);



void lrc_dump_reset(void);

lrc_bool lrc_filter_true(lrc_term);

typedef void (*lrc_prim_print_function)(lrc_term);
void lrc_prim_print_address(lrc_term);
void lrc_prim_print_short(lrc_term);
void lrc_prim_print_untagged(lrc_term);
void lrc_prim_print_tagged(lrc_term);
void lrc_prim_print_install(lrc_prim_print_function);

typedef void (*lrc_term_print_function)(lrc_term);
void lrc_term_print_address(lrc_term);
void lrc_term_print_short(lrc_term);
void lrc_term_print_long(lrc_term);
void lrc_term_print_install(lrc_term_print_function);

void lrc_term_print_indent(lrc_term, int);
void lrc_term_fprint_indent(FILE * f, lrc_term t, int usr_indent_delta);

typedef lrc_term lrc_cell;
typedef void (*lrc_cell_print_function)(lrc_cell);
void lrc_cell_print_fipop(lrc_cell);
void lrc_cell_print_install(lrc_cell_print_function);

int  lrc_memo_time(void);


       int lrc_memo_hits(lrc_cell);
       int lrc_memo_birth(lrc_cell);
lrc_visfun lrc_memo_visfun(lrc_cell);

typedef void lrc_memo_printer(lrc_cell);
typedef lrc_bool lrc_memo_filter(lrc_cell);

void lrc_memo_dump_set_birth_time(int);
void lrc_memo_dump(lrc_memo_filter,lrc_memo_printer);
void lrc_memo_stats(int level);







#ifdef DEBUG
#  define Assert(c,s) if(!(c)) { printf("Assertion error %s\n",s); exit(1); }
#  define AssertI(c,s,i) if(!(c)) { printf("Assertion error %s %d\n",s,i); exit(1); }
#  define DebugStatement(s) s;
#  define DebugDeclaration(d) d;
#else
#  define Assert(c,s) 
#  define AssertI(c,s,i)
#  define DebugStatement(s)
#  define DebugDeclaration(d)
#endif
typedef enum
  { PS_OK, PS_FILE_NOT_READABLE, PS_NO_ENTRY, PS_SYNTAX_ERROR } lrc_parse_state_tp;
void               lrc_set_parse_state(lrc_parse_state_tp);
lrc_parse_state_tp lrc_parse_state(void);
void               lrc_process_whitespace(char * yytext);
lrc_string         lrc_extract_token(char * yytext);
void               lrc_clear_parse_position(void);
void               lrc_get_parse_position(int *line, int *col);

lrc_term lrc_parse_string(lrc_string,int);







