/*
** reals.r
** march 1994 by Maarten Pennings
** Library functions by Matthijs Kuiper
*/
#include "stddef.h"

#include "reals.h"

typedef struct {lrc_ptr tag; int padding; lrc_real r;} real_buf_type, * ptr_real_buf_type;

#define TERM_TO_REAL_BUF_REF(t) ((ptr_real_buf_type)(LRC_USER_DATA(t)))
#define TERM_TO_REAL(t) ( TERM_TO_REAL_BUF_REF(t)->r )

lrc_real lrc_value_real(lrc_term t) {
  ptr_real_buf_type pbuf;
  pbuf = (ptr_real_buf_type)(LRC_USER_DATA(t));
  return pbuf->r;
}

static lrc_term_ix index_real(lrc_real r) {
  lrc_term_ix ix; char * lrc_ptr; int cnt;
  /* strange but lrc_true: chars can be negative */
  for(ix=T__Real,lrc_ptr=(char*)&r,cnt=sizeof(r)/sizeof(*lrc_ptr); cnt>0; cnt--,lrc_ptr++)
    ix = (2*ix + abs(*lrc_ptr)) % lrc_term_tabelsize; 
  return ix;
}

static lrc_bool eq_real(lrc_term t,lrc_ptr b) {
  ptr_real_buf_type pbuf;
  lrc_real r;

  pbuf = (ptr_real_buf_type) b;
  r=pbuf->r;
  /* printf("eq_real comparing %e and %e\n", TERM_TO_REAL(t), r); */
  return LRC_TAG(t)==FIELD(b,0,int) &&  TERM_TO_REAL(t)==r;
  
}

lrc_term C_Real(lrc_real r) {
  real_buf_type buf;
  /* struct {lrc_ptr tag;lrc_real r;} buf; */

  buf.r = r;
  buf.padding=0;
  buf.tag=(lrc_ptr)T__Real;
  /* printf("C_Real %d %d %d\n",
     sizeof(buf), offsetof(real_buf_type,tag), offsetof(real_buf_type,r)); */

  return lrc_shared_prim(index_real(r),eq_real,sizeof(real_buf_type),&buf);
}

/*********************\
** Library functions **
\*********************/

int lrc_real_compare(lrc_real a, lrc_real b) {
    return (a<b) ? lrc_less : ((a==b)?lrc_equal:lrc_greater);
}

int lrc_real_compare_term(lrc_term a, lrc_term b) {
  return lrc_real_compare(TERM_TO_REAL(a),TERM_TO_REAL(b));
}

lrc_bool lrc_real_equal(lrc_real a, lrc_real b) {
  return a==b;
}

lrc_bool lrc_real_equal_term(lrc_term a, lrc_term b) {
  return lrc_real_equal(TERM_TO_REAL(a),TERM_TO_REAL(b));
}

lrc_real lrc_real_default(void) { return 0.0; }

