#ifndef H_REFERENCE
#define H_REFERENCE
struct path_element {
  /* int tag; */
  int childnumber;
  struct path_element * next;
};
typedef struct path_element PathElement;
typedef PathElement * Path;

typedef struct path_pair {
  Path first;
  Path second;
}  PathPair;

typedef enum {
  REF_SUBTREE,
  REF_SUBLIST
} teReferenceKind;

typedef struct reference {
  lrc_term tree;
  teReferenceKind kind;
  Path  sub0;
  Path  sub1;
} * Reference;

Path            path_extend(Path,int);
Path            path_remove_deepest(Path,int);
void            path_print(Path);
int             path_num_edges(Path);
int             path_equal(Path,Path);
int             path_is_ancestor(Path,Path);
Path            path_common_ancestor(Path,Path);
Path            path_take(Path,int);
Path            path_clip(Path, Path);
lrc_term        path_map_to_term(lrc_term,Path);
lrc_term        path_deref_length(lrc_term,Path,int);
Path            path_copy(Path);
int             path_is_root_path(Path);
int      path_is_singleton(Path p);
Path     create_root_path(lrc_term t);
Path     path_concat(Path p1, Path p2);
Path     term_map_to_path(lrc_term root,lrc_term t);

Reference new_reference();
int references_overlap(int num_refs, Reference * refs);
Reference term_to_reference(lrc_term root, lrc_term t);
Reference create_root_reference(lrc_term root);
Reference reference_deref(Reference r);
Reference term_to_reference(lrc_term root, lrc_term t);
Reference subterm_to_reference(lrc_term t);
lrc_term reference_to_term(Reference r);


#endif

