#ifndef H_STYLE_EDITOR
#define H_STYLE_EDITOR
typedef lrc_map Properties;

typedef struct style {
  lrc_string name;
  Properties properties;  
} * Style;

typedef struct style_list {
  struct style_list * next;
  Style element;
} * StyleList;

StyleList add_style(Style head, StyleList l);
Style     get_style(lrc_string style_name, StyleList lst);

Style      style_create(lrc_string name);
void       style_define_property(Style st, lrc_string prop, lrc_string value);
int        style_contains(Style st, lrc_string prop_name);
lrc_string style_lookup(Style st, lrc_string prop_name);
lrc_string style_lookup_str_default(Style st, lrc_string search_key, lrc_string deflt);
int        style_lookup_int(Style st, lrc_string search_key);
int        style_lookup_int_default(Style st, lrc_string search_key, int deflt);

Style style_read_from_file(char * style_name, char * fname);

#endif

