#include <stdio.h>
#include <string.h>
#include "shalloc.h"
#include "unparse_tables.h"
#include "view_tables.h"

extern lrc_views_tp lrc_views;

lrc_views_entry_tp lrc_view_data(char * view_name) {
   int index;
   int found;
   found=0; index=0;
   while (!found) {
      if (strcmp(view_name,lrc_views[index].view_name)==0
          || lrc_views[index].view_prod_table==0 ) {
          found=1;
      }
      else index++;
   }
   if (lrc_views[index].view_prod_table==0) {
     printf("View %s is not defined. No unparsing!", view_name);
   }
   return lrc_views[index];
}

int lrc_view_exists(char * view_name) {
  lrc_views_entry_tp view_rec;
  view_rec=lrc_view_data(view_name);
  return view_rec.view_prod_table!=0;
}

int lrc_prod_first_command_index(lrc_views_entry_tp view_rec, int prod) {
  return (*(view_rec.view_prod_table))[prod].first_command_index;
}

int lrc_prod_num_commands(lrc_views_entry_tp view_rec, int prod) {
  return (*(view_rec.view_prod_table))[prod].num_commands;
}

unparse_commands_entry_tp
 lrc_prod_nth_command(
   lrc_views_entry_tp view_rec,
   int prod,
   int command_num
   ) {
  
  int command_index;

  command_index=(*(view_rec.view_prod_table))[prod].first_command_index+command_num-1;
  return (*(view_rec.view_unparse_commands))[command_index];
}

int lrc_prod_has_unparsing(lrc_views_entry_tp view_rec, int prod) {
  return (*(view_rec.view_prod_table))[prod].kind!=view_entry_default;
}

int lrc_prod_lhs_is_rp(lrc_views_entry_tp view_rec, int prod) {
  unparse_commands_entry_tp  command_entry;

  if (!lrc_prod_has_unparsing(view_rec,prod)) return 0;
  command_entry=lrc_prod_nth_command(view_rec,prod,1);
  return command_entry.command_data[0]=='@';
}

int lrc_view_prod_lhs_is_rp(char * view_name, int prod) {
   lrc_views_entry_tp view_rec;
   view_rec=lrc_view_data(view_name);   /* assumes view exists! */
   return lrc_prod_lhs_is_rp(view_rec,prod);
}

int lrc_prod_child_is_rp(lrc_views_entry_tp view_rec, int prod, int son_num) {
  unparse_commands_entry_tp  command_entry;
  int num_commands;
  int command_number;
  int num_unpa_son_commands;

  if (!lrc_prod_has_unparsing(view_rec,prod)) return 0;
  num_commands=lrc_prod_num_commands(view_rec,prod);
  command_number=1;
  num_unpa_son_commands=0;
  while(command_number<=num_commands) {
    command_entry=lrc_prod_nth_command(view_rec,prod,command_number);
    command_number++;
    if (command_entry.command==unparse_child_command ||
        command_entry.command==unparse_skip_child_command ) {
        num_unpa_son_commands++;
        if (num_unpa_son_commands==son_num) {
          return command_entry.command_data[0]=='@';
        }
    }
  }
  return 0;
}

int lrc_view_prod_child_is_rp(char * view_name, int parent_tag, int child_num) {
  lrc_views_entry_tp view_rec;
  view_rec=lrc_view_data(view_name);   /* assumes view exists! */
  return lrc_prod_child_is_rp(view_rec,parent_tag,child_num);
}

int lrc_prod_allows_text_editing(lrc_views_entry_tp view_rec, int prod) {
  unparse_commands_entry_tp  command_entry;

  if (!lrc_prod_has_unparsing(view_rec,prod)) return 0;
  command_entry=lrc_prod_nth_command(view_rec,prod,1);
  return command_entry.command_data[1]=='Y';
}

int lrc_view_prod_allows_text_editing(char * view_name, int prod) {
  lrc_views_entry_tp view_rec;
  view_rec=lrc_view_data(view_name);   /* assumes view exists! */
  return lrc_prod_allows_text_editing(view_rec,prod);

}



