#ifndef H_VIEWS
#define H_VIEWS
typedef struct text_block {
  struct text_block * next;
  struct text_block * prev;
  Textbuffer text_buffer;
} * TextBlock;

typedef struct {
  TextBlock first;
  TextBlock second;
} TextBlockPair;

typedef struct {
  TextBlock first;
  TextBlock last;
} * TextPieces;

typedef struct view_instance {
  Reference term_ref;   /* reference to the subterm or attribute */
  lrc_term attributes;  /* attributes in the unparsing */
  lrc_views_entry_tp view_table; /* the table with view-entries */
  Fragments fragments; /* the unparse fragments */
} *ViewInstance;

ViewInstance create_view_instance(void);

void vi_clear_unparsing(ViewInstance vi);

void vi_set_attributes(ViewInstance vi, lrc_term attrs);
void vi_set_view(ViewInstance vi, lrc_views_entry_tp table);
char * vi_get_view_name(ViewInstance vi);

void vi_enter_term(ViewInstance vi, lrc_term t);
Reference vi_get_reference(ViewInstance vi);

void vi_compute_fragments(ViewInstance vi);

void vi_print(ViewInstance vi);

#endif

